;CodeVisionAVR C Compiler V1.24.3a Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type           : ATmega64
;Program type        : Application
;Clock frequency     : 11.059200 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : long, width, precision
;(s)scanf features   : int, width
;External SRAM size  : 0
;Data Stack size     : 1024 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "RTC.vec"
	.INCLUDE "RTC.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 /******************************************
;       2 Program : RTC Example for Micro64
;       3 Company : Micromint, Inc
;       4 *********************************************/
;       5      
;       6 #include <mega64.h>
;       7 #include <MMRS485.h>     // Micromints Library for using both USARTs    
;       8 #include <stdio.h>       // Standard I/O library
;       9 #include <delay.h>	 // Library for delays  
;      10 #include <bcd.h>  
;      11 #include <stdlib.h>
;      12 
;      13 unsigned int Pass @0xFFE; 
	.ORG 0xFFE
_Pass:
	.BYTE 0x2
	.ORG 0x500
;      14 unsigned char CLDATA @ 0xFFD;
	.ORG 0xFFD
_CLDATA:
	.BYTE 0x1
	.ORG 0x500
;      15 
;      16 #define MAX_ENTRY_LENGTH 10
;      17 void(*RDTENTHSECOND)(void)=0x7cf3;   
_RDTENTHSECOND:
	.BYTE 0x2
;      18 void(*RDSEC)(void)=0x7cf7;  
_RDSEC:
	.BYTE 0x2
;      19 void(*RDMIN)(void)=0x7cfc;
_RDMIN:
	.BYTE 0x2
;      20 void(*RDHOUR)(void)=0x7d00;
_RDHOUR:
	.BYTE 0x2
;      21 void(*RDDOW)(void)=0x7d05;
_RDDOW:
	.BYTE 0x2
;      22 void(*RDDOM)(void)=0x7d09;
_RDDOM:
	.BYTE 0x2
;      23 void(*RDMONTH)(void)=0x7d0d;
_RDMONTH:
	.BYTE 0x2
;      24 void(*RDYEAR)(void)=0x7d11;
_RDYEAR:
	.BYTE 0x2
;      25 
;      26 void(*WRSEC)(void)=0x7d15;
_WRSEC:
	.BYTE 0x2
;      27 void(*WRMIN)(void)=0x7d1D;
_WRMIN:
	.BYTE 0x2
;      28 void(*WRHOUR)(void)=0x7d21;
_WRHOUR:
	.BYTE 0x2
;      29 void(*WRDOW)(void)=0x7d29;
_WRDOW:
	.BYTE 0x2
;      30 void(*WRDOM)(void)=0x7d2D;
_WRDOM:
	.BYTE 0x2
;      31 void(*WRMONTH)(void)=0x7d31;
_WRMONTH:
	.BYTE 0x2
;      32 void(*WRYEAR)(void)=0x7d35;
_WRYEAR:
	.BYTE 0x2
;      33 
;      34 void(*RDALSEC)(void)=0x7d39;  
_RDALSEC:
	.BYTE 0x2
;      35 void(*RDALMIN)(void)=0x7d3E;
_RDALMIN:
	.BYTE 0x2
;      36 void(*RDALHOUR)(void)=0x7d43;
_RDALHOUR:
	.BYTE 0x2
;      37 void(*RDALDOM)(void)=0x7d48;
_RDALDOM:
	.BYTE 0x2
;      38 void(*RDALMONTH)(void)=0x7d4D;
_RDALMONTH:
	.BYTE 0x2
;      39 
;      40 void(*WRALSEC)(void)=0x7d58;
_WRALSEC:
	.BYTE 0x2
;      41 void(*WRALMIN)(void)=0x7D6B;
_WRALMIN:
	.BYTE 0x2
;      42 void(*WRALHOUR)(void)=0x7D7E; 
_WRALHOUR:
	.BYTE 0x2
;      43 void(*WRALDOM)(void)=0x7D91;
_WRALDOM:
	.BYTE 0x2
;      44 void(*WRALMONTH)(void)=0x7DA4;
_WRALMONTH:
	.BYTE 0x2
;      45   
;      46 void(*ENABLEALARM)(void)=0x7DB9;
_ENABLEALARM:
	.BYTE 0x2
;      47 void(*DISABLEALARM)(void)=0x7DC7;
_DISABLEALARM:
	.BYTE 0x2
;      48 
;      49 void(*ALARMREPEATSEC)(void)=0x7DD2;
_ALARMREPEATSEC:
	.BYTE 0x2
;      50 void(*ALARMREPEATMIN)(void)=0x7DFB;   
_ALARMREPEATMIN:
	.BYTE 0x2
;      51 void(*ALARMREPEATHOUR)(void)=0x7E24;  
_ALARMREPEATHOUR:
	.BYTE 0x2
;      52 void(*ALARMREPEATDAY)(void)=0x7E4D;
_ALARMREPEATDAY:
	.BYTE 0x2
;      53 void(*ALARMREPEATMONTH)(void)=0x7E76;
_ALARMREPEATMONTH:
	.BYTE 0x2
;      54 void(*ALARMREPEATYEAR)(void)=0x7EA2;
_ALARMREPEATYEAR:
	.BYTE 0x2
;      55 
;      56 
;      57 void(*RDALARMFLAGS)(void)=0x7ECB;
_RDALARMFLAGS:
	.BYTE 0x2
;      58 
;      59 
;      60 void disMainMenu(void);
;      61 void setClock(void);
;      62 void setAlarm(void);
;      63 void readAlarm(void);
;      64 void enable_Alarm(void);
;      65 void disable_Alarm(void);
;      66 void setAlarmRepeat(void);
;      67 int getBCD(void);    
;      68 unsigned char checkUSART1(void);
;      69 // External Interrupt 5 service routine
;      70 interrupt [EXT_INT5] void ext_int5_isr(void)
;      71 {      

	.CSEG
_ext_int5_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      72 #asm("cli") 
	cli
;      73 (*RDALARMFLAGS)();  
	__CALL1MN _RDALARMFLAGS,0
;      74 printf("Alarm Flags = %02d\r\n", Pass);
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Pass
	LDS  R31,_Pass+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;      75 printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      76 printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      77 printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      78 printf("An Alarm Occured\r\n"); 
	__POINTW1FN _0,21
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      79 printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      80 printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      81 printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      82 #asm("sei")
	sei
;      83 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;      84 
;      85 // Declare your global variables here
;      86 int COM;         // if COM = 0 then use USART0 if it = 1 then use USART1     
;      87 
;      88 void main(void)
;      89 {
_main:
;      90 // Declare your local variables here 
;      91 
;      92 // External Interrupt(s) initialization
;      93 // INT0: Off
;      94 // INT1: Off
;      95 // INT2: Off
;      96 // INT3: Off
;      97 // INT4: Off
;      98 // INT5: On
;      99 // INT5 Mode: Low level
;     100 // INT6: Off
;     101 // INT7: Off
;     102 EICRA=0x00;
	LDI  R30,LOW(0)
	STS  0x6A,R30
;     103 EICRB=0x00;
	OUT  0x3A,R30
;     104 EIMSK=0x20;
	LDI  R30,LOW(32)
	OUT  0x39,R30
;     105 EIFR=0x20;
	OUT  0x38,R30
;     106 
;     107 // Set up USART1's Baud rate at 9600 bps with a 11.0592 MHz Crystal
;     108 UCSR1A=0x00;      // RX EN, TX EN
	LDI  R30,LOW(0)
	STS  0x9B,R30
;     109 UCSR1B=0x18;     // RX EN, TX EN
	LDI  R30,LOW(24)
	STS  0x9A,R30
;     110 UCSR1C=0x06;     // 8N1
	LDI  R30,LOW(6)
	STS  0x9D,R30
;     111 UBRR1H=0x00;    // Baud rate high - 9600
	LDI  R30,LOW(0)
	STS  0x98,R30
;     112 UBRR1L=0x47;   // Baud rate low 
	LDI  R30,LOW(71)
	STS  0x99,R30
;     113 
;     114 delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     115     COM = 1;                           // Use USART1  
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 4,5
;     116     DDRD.6 = 0;			   // Make PORTD.6 an output  
	CBI  0x11,6
;     117     PORTD.6 = 1; 			   // Enable the RS485 control line     
	SBI  0x12,6
;     118     printf("Press any key to display the main menu\r\n");
	__POINTW1FN _0,40
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     119     printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     120 while (1)
_0x25:
;     121       {  
;     122         (*RDDOW)(); 
	__CALL1MN _RDDOW,0
;     123        switch(Pass)
	LDS  R30,_Pass
	LDS  R31,_Pass+1
;     124         {
;     125           case 1 :
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2B
;     126              printf("Sunday ");
	__POINTW1FN _0,81
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     127              break;  
	RJMP _0x2A
;     128           case 2 : 
_0x2B:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2C
;     129              printf("Monday ");
	__POINTW1FN _0,89
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     130              break;
	RJMP _0x2A
;     131           case 3 :
_0x2C:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2D
;     132              printf("Tuesday ");
	__POINTW1FN _0,97
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     133              break;
	RJMP _0x2A
;     134           case 4 :
_0x2D:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x2E
;     135              printf("Wednesday ");
	__POINTW1FN _0,106
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     136              break;
	RJMP _0x2A
;     137           case 5 :
_0x2E:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x2F
;     138              printf("Thursday ");
	__POINTW1FN _0,117
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     139              break;
	RJMP _0x2A
;     140           case 6 :
_0x2F:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x30
;     141              printf("Friday ");
	__POINTW1FN _0,127
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     142              break;   
	RJMP _0x2A
;     143           case 7 :
_0x30:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x2A
;     144              printf("Saturday ");
	__POINTW1FN _0,135
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     145              break;
;     146         }      
_0x2A:
;     147        
;     148        (*RDMONTH)();
	__CALL1MN _RDMONTH,0
;     149        printf("%02d",bcd2bin(Pass));
	__POINTW1FN _0,145
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     150        (*RDDOM)();
	__CALL1MN _RDDOM,0
;     151        printf("/%02d",bcd2bin(Pass));  
	__POINTW1FN _0,150
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     152        (*RDYEAR)();
	__CALL1MN _RDYEAR,0
;     153        printf("/%02d",bcd2bin(Pass));
	__POINTW1FN _0,150
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     154        (*RDHOUR)();
	__CALL1MN _RDHOUR,0
;     155        printf(" %02d",bcd2bin(Pass));                         
	__POINTW1FN _0,156
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     156        (*RDMIN)();
	__CALL1MN _RDMIN,0
;     157        printf(":%02d",bcd2bin(Pass));
	__POINTW1FN _0,162
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     158        (*RDSEC)();
	__CALL1MN _RDSEC,0
;     159        printf(":%02d",bcd2bin(Pass));
	__POINTW1FN _0,162
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     160        (*RDTENTHSECOND)(); 
	__CALL1MN _RDTENTHSECOND,0
;     161        printf(":%02d",bcd2bin(Pass));
	__POINTW1FN _0,162
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     162        printf("\r");  
	__POINTW1FN _0,168
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     163        if (checkUSART1()>0)
	RCALL _checkUSART1
	MOV  R26,R30
	LDI  R30,LOW(0)
	CP   R30,R26
	BRSH _0x32
;     164          disMainMenu();
	RCALL _disMainMenu
;     165       };
_0x32:
	RJMP _0x25
;     166 }
_0x33:
	RJMP _0x33
;     167 
;     168 void disMainMenu(void)
;     169 {
_disMainMenu:
;     170 char rec;           
;     171     printf("\r\n");
	ST   -Y,R16
;	rec -> R16
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     172     printf("Main Menu \r\n");
	__POINTW1FN _0,170
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     173     printf("1 - Set the Clock\r\n");
	__POINTW1FN _0,183
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     174     printf("2 - Set the Alarm\r\n");
	__POINTW1FN _0,203
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     175     printf("3 - Read the Clock\r\n");
	__POINTW1FN _0,223
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     176     printf("4 - Read the Alarm\r\n");
	__POINTW1FN _0,244
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     177     printf("5 - Enable the Alarm\r\n");
	__POINTW1FN _0,265
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     178     printf("6 - Disable the Alarm\r\n");
	__POINTW1FN _0,288
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     179     printf("7 - Set how often the Alarm Repeats\r\n");    
	__POINTW1FN _0,312
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x1
;     180     rec = getchar();
;     181         switch(rec)
;     182         {
;     183           case '1' :
	BRNE _0x37
;     184              setClock();
	RCALL _setClock
;     185              break;  
	RJMP _0x36
;     186           case '2' : 
_0x37:
	CPI  R30,LOW(0x32)
	BRNE _0x38
;     187              setAlarm();
	RCALL _setAlarm
;     188              break;
	RJMP _0x36
;     189           case '3' :
_0x38:
	CPI  R30,LOW(0x33)
	BREQ _0x36
;     190              break;
;     191           case '4' :
	CPI  R30,LOW(0x34)
	BRNE _0x3A
;     192              readAlarm();
	RCALL _readAlarm
;     193              break;
	RJMP _0x36
;     194           case '5' :
_0x3A:
	CPI  R30,LOW(0x35)
	BRNE _0x3B
;     195              enable_Alarm();
	RCALL _enable_Alarm
;     196              break;
	RJMP _0x36
;     197           case '6' :
_0x3B:
	CPI  R30,LOW(0x36)
	BRNE _0x3C
;     198              disable_Alarm();
	RCALL _disable_Alarm
;     199              break;   
	RJMP _0x36
;     200           case '7' :
_0x3C:
	CPI  R30,LOW(0x37)
	BRNE _0x36
;     201              setAlarmRepeat();
	RCALL _setAlarmRepeat
;     202              break; 
;     203         }
_0x36:
;     204         printf("Press any key to display the main menu\r\n");
	__POINTW1FN _0,40
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     205         printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     206 }
	LD   R16,Y+
	RET
;     207 
;     208 void setClock(void)
;     209 {
_setClock:
;     210 unsigned char Seconds;    
;     211 unsigned char Minutes;
;     212 unsigned char Hours;
;     213 unsigned char Month;
;     214 unsigned char DOM;
;     215 unsigned char DOW;
;     216    printf("Please enter what you would like to set the seconds to.\r\n");
	CALL __SAVELOCR6
;	Seconds -> R16
;	Minutes -> R17
;	Hours -> R18
;	Month -> R19
;	DOM -> R20
;	DOW -> R21
	__POINTW1FN _0,350
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     217    Seconds = getBCD(); 
	MOV  R16,R30
;     218    printf("Please enter what you would like to set the minute to.\r\n");
	__POINTW1FN _0,408
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     219    Minutes = getBCD();
	MOV  R17,R30
;     220    printf("Please enter what you would like to set the hour to.\r\n");
	__POINTW1FN _0,465
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     221    Hours = getBCD();
	MOV  R18,R30
;     222    printf("Please enter what you would like to set the Day of the Week to.\r\n"); 
	__POINTW1FN _0,520
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     223    printf("1 - Sunday\r\n");
	__POINTW1FN _0,586
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     224    printf("2 - Monday\r\n");
	__POINTW1FN _0,599
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     225    printf("3 - Tuesday\r\n");
	__POINTW1FN _0,612
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     226    printf("4 - Wednesday\r\n");
	__POINTW1FN _0,626
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     227    printf("5 - Thursday\r\n");
	__POINTW1FN _0,642
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     228    printf("6 - Friday\r\n");
	__POINTW1FN _0,657
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     229    printf("7 - Saturday\r\n"); 
	__POINTW1FN _0,670
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     230    DOW = getBCD(); 
	MOV  R21,R30
;     231    printf("Please enter what you would like to set the Month to.\r\n"); 
	__POINTW1FN _0,685
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     232    Month = getBCD();  
	MOV  R19,R30
;     233    printf("Please enter what you would like to set the Day of the Month to.\r\n");
	__POINTW1FN _0,741
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     234    DOM = getBCD(); 
	MOV  R20,R30
;     235    printf("Please enter what you would like to set the Year to.\r\n"); 
	__POINTW1FN _0,808
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     236    CLDATA = getBCD();
	STS  _CLDATA,R30
;     237    (*WRYEAR)();
	__CALL1MN _WRYEAR,0
;     238    CLDATA = Seconds;
	STS  _CLDATA,R16
;     239    (*WRSEC)();  
	__CALL1MN _WRSEC,0
;     240    CLDATA = Minutes;
	STS  _CLDATA,R17
;     241    (*WRMIN)();     
	__CALL1MN _WRMIN,0
;     242    CLDATA = Hours;
	STS  _CLDATA,R18
;     243    (*WRHOUR)();  
	__CALL1MN _WRHOUR,0
;     244    CLDATA = DOW;
	STS  _CLDATA,R21
;     245    (*WRDOW)(); 
	__CALL1MN _WRDOW,0
;     246    CLDATA = Month;
	STS  _CLDATA,R19
;     247    (*WRMONTH)(); 
	__CALL1MN _WRMONTH,0
;     248    CLDATA = DOM;
	STS  _CLDATA,R20
;     249    (*WRDOM)();
	__CALL1MN _WRDOM,0
;     250 }
	CALL __LOADLOCR6
	ADIW R28,6
	RET
;     251 void setAlarm(void)
;     252 { 
_setAlarm:
;     253    printf("Please enter what you would like to set the Alarm seconds to.\r\n");       
	__POINTW1FN _0,863
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     254    CLDATA = getBCD();
	STS  _CLDATA,R30
;     255    (*WRALSEC)();  
	__CALL1MN _WRALSEC,0
;     256    printf("Please enter what you would like to set the Alarm minutes to.\r\n");
	__POINTW1FN _0,927
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     257    CLDATA = getBCD();
	STS  _CLDATA,R30
;     258    (*WRALMIN)();  
	__CALL1MN _WRALMIN,0
;     259    printf("Please enter what you would like to set the Alarm hour to.\r\n");
	__POINTW1FN _0,991
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     260    CLDATA = getBCD();
	STS  _CLDATA,R30
;     261    (*WRALHOUR)(); 
	__CALL1MN _WRALHOUR,0
;     262    printf("Please enter what you would like to set the Alarm Month to.\r\n");
	__POINTW1FN _0,1052
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     263    CLDATA = getBCD();
	STS  _CLDATA,R30
;     264    (*WRALMONTH)();  
	__CALL1MN _WRALMONTH,0
;     265    printf("Please enter what you would like to set the Alarm Day of the Month to.\r\n");
	__POINTW1FN _0,1114
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     266    CLDATA = getBCD();
	STS  _CLDATA,R30
;     267    (*WRALDOM)(); 
	__CALL1MN _WRALDOM,0
;     268 }
	RET
;     269 void readAlarm(void)
;     270 {
_readAlarm:
;     271       printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     272       printf("The alarm is set to ");
	__POINTW1FN _0,1187
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     273       (*RDALMONTH)();
	__CALL1MN _RDALMONTH,0
;     274       printf("%02d",bcd2bin(Pass)); 
	__POINTW1FN _0,145
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     275       (*RDALDOM)();
	__CALL1MN _RDALDOM,0
;     276       printf("/%02d",bcd2bin(Pass));  
	__POINTW1FN _0,150
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     277       (*RDALHOUR)();
	__CALL1MN _RDALHOUR,0
;     278       printf(" %02d",bcd2bin(Pass));                         
	__POINTW1FN _0,156
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     279       (*RDALMIN)();
	__CALL1MN _RDALMIN,0
;     280       printf(":%02d",bcd2bin(Pass));
	__POINTW1FN _0,162
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     281       (*RDALSEC)();
	__CALL1MN _RDALSEC,0
;     282       printf(":%02d",bcd2bin(Pass));  
	__POINTW1FN _0,162
	CALL SUBOPT_0x0
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     283       printf("\r\n");  
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     284       printf("\r\n");
	__POINTW1FN _0,18
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     285 }
	RET
;     286 void enable_Alarm(void)
;     287 {
_enable_Alarm:
;     288 // Global interrupts enable
;     289 #asm("sei")
	sei
;     290 (*ENABLEALARM)();
	__CALL1MN _ENABLEALARM,0
;     291 }   
	RET
;     292 
;     293 void disable_Alarm(void)
;     294 {
_disable_Alarm:
;     295 // Global interrupts disabled
;     296 #asm("cli") 
	cli
;     297 (*DISABLEALARM)();
	__CALL1MN _DISABLEALARM,0
;     298 }
	RET
;     299 void setAlarmRepeat(void)
;     300 {
_setAlarmRepeat:
;     301 char recx;   
;     302    printf("Please enter what you would like to set the alarm repeat to.\r\n"); 
	ST   -Y,R16
;	recx -> R16
	__POINTW1FN _0,1208
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     303    printf("1 - Once a Second\r\n");
	__POINTW1FN _0,1271
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     304    printf("2 - Once a Minute\r\n");
	__POINTW1FN _0,1291
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     305    printf("3 - Once a Hour\r\n");
	__POINTW1FN _0,1311
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     306    printf("4 - Once a Day\r\n");
	__POINTW1FN _0,1329
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     307    printf("5 - Once a Month\r\n");
	__POINTW1FN _0,1346
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     308    printf("6 - Once a Year\r\n");
	__POINTW1FN _0,1365
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x1
;     309    recx = getchar();
;     310         switch(recx)
;     311         {
;     312           case '1' : 
	BRNE _0x41
;     313              (*ALARMREPEATSEC)();
	__CALL1MN _ALARMREPEATSEC,0
;     314              break;  
	RJMP _0x40
;     315           case '2' : 
_0x41:
	CPI  R30,LOW(0x32)
	BRNE _0x42
;     316              (*ALARMREPEATMIN)();
	__CALL1MN _ALARMREPEATMIN,0
;     317              break;
	RJMP _0x40
;     318           case '3' :
_0x42:
	CPI  R30,LOW(0x33)
	BRNE _0x43
;     319              (*ALARMREPEATHOUR)();
	__CALL1MN _ALARMREPEATHOUR,0
;     320              break;
	RJMP _0x40
;     321           case '4' :
_0x43:
	CPI  R30,LOW(0x34)
	BRNE _0x44
;     322              (*ALARMREPEATDAY)();
	__CALL1MN _ALARMREPEATDAY,0
;     323              break;
	RJMP _0x40
;     324           case '5' :
_0x44:
	CPI  R30,LOW(0x35)
	BRNE _0x45
;     325              (*ALARMREPEATMONTH)();
	__CALL1MN _ALARMREPEATMONTH,0
;     326              break;
	RJMP _0x40
;     327           case '6' :
_0x45:
	CPI  R30,LOW(0x36)
	BRNE _0x40
;     328              (*ALARMREPEATYEAR)();
	__CALL1MN _ALARMREPEATYEAR,0
;     329              break;   
;     330         }
_0x40:
;     331 }
	RJMP _0xEA
;     332 
;     333 int getBCD(void)
;     334 {
_getBCD:
;     335 char mystr[MAX_ENTRY_LENGTH + 1]; //Declare a string   
;     336 char c;
;     337 
;     338         COM = 1; 
	SBIW R28,11
	ST   -Y,R16
;	mystr -> Y+1
;	c -> R16
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 4,5
;     339         DDRD.6 = 0;			   // Make PORTD.6 an output  
	CBI  0x11,6
;     340         PORTD.6 = 1; 			   // Enable the RS485 control line  
	SBI  0x12,6
;     341         c = 0;    
	LDI  R16,LOW(0)
;     342         while( c < MAX_ENTRY_LENGTH)
_0x47:
	CPI  R16,10
	BRSH _0x49
;     343         {
;     344           mystr[c++] = getchar();
	MOV  R30,R16
	SUBI R16,-1
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,1
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL _getchar
	POP  R26
	POP  R27
	ST   X,R30
;     345           if (mystr[c-1] == 13)
	MOV  R30,R16
	SUBI R30,LOW(1)
	CALL SUBOPT_0x3
	LD   R26,X
	CPI  R26,LOW(0xD)
	BREQ _0x49
;     346              break;
;     347         }
	RJMP _0x47
_0x49:
;     348         mystr[c] = '\0'; 
	MOV  R30,R16
	CALL SUBOPT_0x3
	LDI  R30,LOW(0)
	ST   X,R30
;     349            
;     350         return  bin2bcd(atoi(mystr));
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	ST   -Y,R30
	CALL _bin2bcd
	LDI  R31,0
	LDD  R16,Y+0
	ADIW R28,12
	RET
;     351 }
;     352 unsigned char checkUSART1(void)
;     353 { 
_checkUSART1:
;     354 unsigned char status; 
;     355 status = UCSR1A;
	ST   -Y,R16
;	status -> R16
	LDS  R16,155
;     356 status = status & 0x80; // mask out all of the bits in the UCSR1A register except the receive complete
	ANDI R16,LOW(128)
;     357 switch(status)
	MOV  R30,R16
;     358         {
;     359           case 0x0:      //No characters came into the USART
	CPI  R30,0
	BRNE _0x4E
;     360              return 0;
	LDI  R30,LOW(0)
	RJMP _0xEA
;     361              break;  
;     362           case 0x80:    // A character came into the USART
_0x4E:
	CPI  R30,LOW(0x80)
	BRNE _0x4D
;     363              status = UDR1;
	LDS  R16,156
;     364              return 255;
	LDI  R30,LOW(255)
;     365              break; 
;     366         }
_0x4D:
;     367 }
_0xEA:
	LD   R16,Y+
	RET
;     368 

_getchar:
	ST   -Y,R17
	ST   -Y,R16
	__GETW1R 4,5
	SBIW R30,0
	BRNE _0x53
_0x54:
_0x57:
	IN   R30,0xB
	MOV  R16,R30
	ANDI R30,LOW(0x80)
	BREQ _0x57
	IN   R17,12
	MOV  R30,R16
	ANDI R30,LOW(0x1C)
	BRNE _0x5A
	MOV  R30,R17
	RJMP _0xE9
_0x5A:
	RJMP _0x54
	RJMP _0x5B
_0x53:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x52
_0x5B:
_0x5D:
_0x60:
	LDS  R30,155
	MOV  R16,R30
	ANDI R30,LOW(0x80)
	BREQ _0x60
	LDS  R17,156
	MOV  R30,R16
	ANDI R30,LOW(0x1C)
	BRNE _0x63
	MOV  R30,R17
	RJMP _0xE9
_0x63:
	RJMP _0x5D
_0x52:
_0xE9:
	LD   R16,Y+
	LD   R17,Y+
	RET
_putchar:
	__GETW1R 4,5
	SBIW R30,0
	BRNE _0x67
_0x68:
	SBIS 0xB,5
	RJMP _0x68
	LD   R30,Y
	OUT  0xC,R30
	RJMP _0x66
_0x67:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x66
_0x6C:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x6C
	LD   R30,Y
	STS  0x9C,R30
_0x6F:
	LDS  R30,155
	ANDI R30,LOW(0x40)
	BREQ _0x6F
_0x66:
	ADIW R28,1
	RET
__put_G3:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x72
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x73
_0x72:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0x73:
	ADIW R28,3
	RET
__print_sign_G3:
    ;flags&=~F_SIGNED
    andi r17,~4
    ;_put(s,ptr_ps)
    ldd  r30,y+17
    st   -y,r30
    ldd  r30,y+19
    ldd  r31,y+20
    st   -y,r31
    st   -y,r30
    rcall put
    ;if (width) --width
    cpi  r20,0
    breq width0
    dec  r20
width0:
	RET
__print_G3:
	SBIW R28,12
	CALL __SAVELOCR6
	LDI  R16,0
_0x74:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ADIW R30,1
	STD  Y+22,R30
	STD  Y+22+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x76
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x7A
	CPI  R19,37
	BRNE _0x7B
	LDI  R16,LOW(1)
	RJMP _0x7C
_0x7B:
	CALL SUBOPT_0x4
_0x7C:
	RJMP _0x79
_0x7A:
	CPI  R30,LOW(0x1)
	BRNE _0x7D
	CPI  R19,37
	BRNE _0x7E
	CALL SUBOPT_0x4
	LDI  R16,LOW(0)
	RJMP _0x79
_0x7E:
	LDI  R16,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+17,R30
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x7F
	LDI  R17,LOW(1)
	RJMP _0x79
_0x7F:
	CPI  R19,43
	BRNE _0x80
	LDI  R30,LOW(43)
	STD  Y+17,R30
	RJMP _0x79
_0x80:
	CPI  R19,32
	BRNE _0x81
	LDI  R30,LOW(32)
	STD  Y+17,R30
	RJMP _0x79
_0x81:
	RJMP _0x82
_0x7D:
	CPI  R30,LOW(0x2)
	BRNE _0x83
_0x82:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x84
	ORI  R17,LOW(128)
	RJMP _0x79
_0x84:
	RJMP _0x85
_0x83:
	CPI  R30,LOW(0x3)
	BRNE _0x86
_0x85:
	CPI  R19,48
	BRLO _0x88
	CPI  R19,58
	BRLO _0x89
_0x88:
	RJMP _0x87
_0x89:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x79
_0x87:
	LDI  R21,LOW(0)
	CPI  R19,46
	BRNE _0x8A
	LDI  R16,LOW(4)
	RJMP _0x79
_0x8A:
	RJMP _0x8B
_0x86:
	CPI  R30,LOW(0x4)
	BRNE _0x8D
	CPI  R19,48
	BRLO _0x8F
	CPI  R19,58
	BRLO _0x90
_0x8F:
	RJMP _0x8E
_0x90:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R21,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x79
_0x8E:
_0x8B:
	CPI  R19,108
	BRNE _0x91
	ORI  R17,LOW(2)
	LDI  R16,LOW(5)
	RJMP _0x79
_0x91:
	RJMP _0x92
_0x8D:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x79
_0x92:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x97
	CALL SUBOPT_0x5
	LD   R30,X
	CALL SUBOPT_0x6
	RJMP _0x98
_0x97:
	CPI  R30,LOW(0x73)
	BRNE _0x9A
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlen
	MOV  R16,R30
	RJMP _0x9B
_0x9A:
	CPI  R30,LOW(0x70)
	BRNE _0x9D
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x9B:
	ANDI R17,LOW(127)
	CPI  R21,0
	BREQ _0x9F
	CP   R21,R16
	BRLO _0xA0
_0x9F:
	RJMP _0x9E
_0xA0:
	MOV  R16,R21
_0x9E:
	LDI  R21,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+16,R30
	LDI  R18,LOW(0)
	RJMP _0xA1
_0x9D:
	CPI  R30,LOW(0x64)
	BREQ _0xA4
	CPI  R30,LOW(0x69)
	BRNE _0xA5
_0xA4:
	ORI  R17,LOW(4)
	RJMP _0xA6
_0xA5:
	CPI  R30,LOW(0x75)
	BRNE _0xA7
_0xA6:
	LDI  R30,LOW(10)
	STD  Y+16,R30
	SBRS R17,1
	RJMP _0xA8
	__GETD1N 0x3B9ACA00
	__PUTD1S 8
	LDI  R16,LOW(10)
	RJMP _0xA9
_0xA8:
	__GETD1N 0x2710
	__PUTD1S 8
	LDI  R16,LOW(5)
	RJMP _0xA9
_0xA7:
	CPI  R30,LOW(0x58)
	BRNE _0xAB
	ORI  R17,LOW(8)
	RJMP _0xAC
_0xAB:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0xE8
_0xAC:
	LDI  R30,LOW(16)
	STD  Y+16,R30
	SBRS R17,1
	RJMP _0xAE
	__GETD1N 0x10000000
	__PUTD1S 8
	LDI  R16,LOW(8)
	RJMP _0xA9
_0xAE:
	__GETD1N 0x1000
	__PUTD1S 8
	LDI  R16,LOW(4)
_0xA9:
	CPI  R21,0
	BREQ _0xAF
	ANDI R17,LOW(127)
	RJMP _0xB0
_0xAF:
	LDI  R21,LOW(1)
_0xB0:
	SBRS R17,1
	RJMP _0xB1
	CALL SUBOPT_0x5
	CALL __GETD1P
	__PUTD1S 12
	RJMP _0xB2
_0xB1:
	SBRS R17,2
	RJMP _0xB3
	CALL SUBOPT_0x5
	CALL __GETW1P
	CALL __CWD1
	RJMP _0xEB
_0xB3:
	CALL SUBOPT_0x5
	CALL __GETW1P
	CLR  R22
	CLR  R23
_0xEB:
	__PUTD1S 12
_0xB2:
	SBRS R17,2
	RJMP _0xB5
	__GETD2S 12
	CALL __CPD20
	BRGE _0xB6
	__GETD1S 12
	CALL __ANEGD1
	__PUTD1S 12
	LDI  R30,LOW(45)
	STD  Y+17,R30
_0xB6:
	LDD  R30,Y+17
	CPI  R30,0
	BREQ _0xB7
	SUBI R16,-LOW(1)
	SUBI R21,-LOW(1)
	RJMP _0xB8
_0xB7:
	ANDI R17,LOW(251)
_0xB8:
_0xB5:
	MOV  R18,R21
_0xA1:
	SBRC R17,0
	RJMP _0xB9
_0xBA:
	CP   R16,R20
	BRSH _0xBD
	CP   R18,R20
	BRLO _0xBE
_0xBD:
	RJMP _0xBC
_0xBE:
	SBRS R17,7
	RJMP _0xBF
	SBRS R17,2
	RJMP _0xC0
	ANDI R17,LOW(251)
	LDD  R19,Y+17
	SUBI R16,LOW(1)
	RJMP _0xC1
_0xC0:
	LDI  R19,LOW(48)
_0xC1:
	RJMP _0xC2
_0xBF:
	LDI  R19,LOW(32)
_0xC2:
	CALL SUBOPT_0x4
	SUBI R20,LOW(1)
	RJMP _0xBA
_0xBC:
_0xB9:
_0xC3:
	CP   R16,R21
	BRSH _0xC5
	ORI  R17,LOW(16)
	SBRS R17,2
	RJMP _0xC6
	CALL __print_sign_G3
	SUBI R16,LOW(1)
	SUBI R21,LOW(1)
_0xC6:
	LDI  R30,LOW(48)
	CALL SUBOPT_0x6
	CPI  R20,0
	BREQ _0xC7
	SUBI R20,LOW(1)
_0xC7:
	SUBI R21,LOW(1)
	RJMP _0xC3
_0xC5:
	MOV  R18,R16
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0xC8
_0xC9:
	CPI  R18,0
	BREQ _0xCB
	SBRS R17,3
	RJMP _0xCC
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xEC
_0xCC:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xEC:
	ST   -Y,R30
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	ST   -Y,R31
	ST   -Y,R30
	CALL __put_G3
	CPI  R20,0
	BREQ _0xCE
	SUBI R20,LOW(1)
_0xCE:
	SUBI R18,LOW(1)
	RJMP _0xC9
_0xCB:
	RJMP _0xCF
_0xC8:
_0xD1:
	__GETD1S 8
	__GETD2S 12
	CALL __DIVD21U
	MOV  R19,R30
	LDI  R30,LOW(9)
	CP   R30,R19
	BRSH _0xD3
	SBRS R17,3
	RJMP _0xD4
	SUBI R19,-LOW(55)
	RJMP _0xD5
_0xD4:
	SUBI R19,-LOW(87)
_0xD5:
	RJMP _0xD6
_0xD3:
	SUBI R19,-LOW(48)
_0xD6:
	SBRC R17,4
	RJMP _0xD8
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0xDA
	__GETD2S 8
	__CPD2N 0x1
	BRNE _0xD9
_0xDA:
	RJMP _0xDC
_0xD9:
	CP   R21,R18
	BRLO _0xDD
	LDI  R19,LOW(48)
	RJMP _0xDC
_0xDD:
	CP   R20,R18
	BRLO _0xDF
	SBRS R17,0
	RJMP _0xE0
_0xDF:
	RJMP _0xDE
_0xE0:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xE1
	LDI  R19,LOW(48)
_0xDC:
	ORI  R17,LOW(16)
	SBRS R17,2
	RJMP _0xE2
	CALL __print_sign_G3
_0xE2:
_0xE1:
_0xD8:
	CALL SUBOPT_0x4
	CPI  R20,0
	BREQ _0xE3
	SUBI R20,LOW(1)
_0xE3:
_0xDE:
	SUBI R18,LOW(1)
	__GETD1S 8
	__GETD2S 12
	CALL __MODD21U
	__PUTD1S 12
	LDD  R30,Y+16
	__GETD2S 8
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	__PUTD1S 8
	CALL __CPD10
	BREQ _0xD2
	RJMP _0xD1
_0xD2:
_0xCF:
	SBRS R17,0
	RJMP _0xE4
_0xE5:
	CPI  R20,0
	BREQ _0xE7
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x6
	RJMP _0xE5
_0xE7:
_0xE4:
_0xE8:
_0x98:
	LDI  R16,LOW(0)
_0x79:
	RJMP _0x74
_0x76:
	CALL __LOADLOCR6
	ADIW R28,24
	RET
_printf:
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	__PUTW2R 16,17
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G3
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
_atoi:
   	ldd  r27,y+1
   	ld   r26,y
__atoi0:
   	ld   r30,x
	ST   -Y,R30
	CALL _isspace
   	tst  r30
   	breq __atoi1
   	adiw r26,1
   	rjmp __atoi0
__atoi1:
   	clt
   	ld   r30,x
   	cpi  r30,'-'
   	brne __atoi2
   	set
   	rjmp __atoi3
__atoi2:
   	cpi  r30,'+'
   	brne __atoi4
__atoi3:
   	adiw r26,1
__atoi4:
   	clr  r22
   	clr  r23
__atoi5:
   	ld   r30,x
	ST   -Y,R30
	CALL _isdigit
   	tst  r30
   	breq __atoi6
   	mov  r30,r22
   	mov  r31,r23
   	lsl  r22
   	rol  r23
   	lsl  r22
   	rol  r23
   	add  r22,r30
   	adc  r23,r31
   	lsl  r22
   	rol  r23
   	ld   r30,x+
   	clr  r31
   	subi r30,'0'
   	add  r22,r30
   	adc  r23,r31
   	rjmp __atoi5
__atoi6:
   	mov  r30,r22
   	mov  r31,r23
   	brtc __atoi7
   	com  r30
   	com  r31
   	adiw r30,1
__atoi7:
   	adiw r28,2
   	ret

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Pass
	LDS  R31,_Pass+1
	ST   -Y,R30
	CALL _bcd2bin
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	CALL _printf
	ADIW R28,2
	CALL _getchar
	MOV  R16,R30
	MOV  R30,R16
	CPI  R30,LOW(0x31)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x2:
	CALL _printf
	ADIW R28,2
	JMP  _getBCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	ST   -Y,R19
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x5:
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	SBIW R26,4
	STD  Y+20,R26
	STD  Y+20+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x6:
	ST   -Y,R30
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	CALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

_isdigit:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,'0'
	brlo __isdigit0
	cpi  r31,'9'+1
	brlo __isdigit1
__isdigit0:
	clr  r30
__isdigit1:
	ret

_isspace:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,' '
	breq __isspace1
	cpi  r31,9
	brlo __isspace0
	cpi  r31,14
	brlo __isspace1
__isspace0:
	clr  r30
__isspace1:
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xACD
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_bcd2bin:
	ld   r30,y
	swap r30
	andi r30,0xf
	mov  r26,r30
	lsl  r26
	lsl  r26
	add  r30,r26
	lsl  r30
	ld   r26,y+
	andi r26,0xf
	add  r30,r26
	ret

_bin2bcd:
	ld   r26,y+
	clr  r30
__bin2bcd0:
	subi r26,10
	brmi __bin2bcd1
	subi r30,-16
	rjmp __bin2bcd0
__bin2bcd1:
	subi r26,-10
	add  r30,r26
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	LDI  R22,0
	LDI  R23,0
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R19
	CLR  R20
	LDI  R21,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R19
	ROL  R20
	SUB  R0,R30
	SBC  R1,R31
	SBC  R19,R22
	SBC  R20,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R19,R22
	ADC  R20,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R21
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOV  R24,R19
	MOV  R25,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
